const express = require("express");
const cors = require("cors");
const logger = require("morgan");

const { pg, Pool, Client } = require("pg");

const app = express();
app.use("*", cors());
app.use(logger("dev"));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));

const r_pool = new Pool({
  user: "postgres",
  host: "127.0.0.1",
  database: "richelet",
  password: "postgres",
  port: "5432"
});

const s_richelet =
  "select id_, carpeta, vence,(select descripcion from pais where id_ = pais) as pais, marca from marca ";

const client = new Client({
  user: "react_db_user",
  host: "localhost",
  database: "react_db",
  password: "r34cts",
  port: 5432
});

console.log("SERVER");

app.get("/", (request, response) => {
  console.log("root");
  response.json({
    info: "Node.js, Express, and Postgres API",
    connected: client._connected,
    hadError: client._hadError
  });
});

app.get("/api/customers", (request, response) => {
  console.log(request.query);
  r_pool.query(s_richelet + " limit 40", (error, results) => {
    if (error) {
      throw error;
    }

    response.status(200).json({ rows: results.rows });
  });
});


app.get("/api/mallazaranda", (request, response) => {
  console.log(request.query);

const client = new Client({
    user: "react_db_user",
    host: "localhost",
    database: "react_db",
    password: "r34cts",
    port: 5432
  });
 
   client.connect();
  client.query( "select id, date, descripcion, luz,diametro, area, peso_kg, ancho_max  from malla_zaranda  limit 4000", (error, results) => {
    if (error) {
      throw error;
    }

    response.status(200).json({ rows: results.rows });
  });
});


app.get("/api/consultaLista", (request, response) => {
  console.log(request.body);
  const client = new Client({
    user: "react_db_user",
    host: "localhost",
    database: "react_db",
    password: "r34cts",
    port: 5432
  });

  client.connect();
  client.query("select * from mensajes", (error, results) => {
    if (error) {
      throw error;
    }
    response.status(200).json(results);
  });
});
/*  POST */

app.post("/api/filter", (request, response) => {
  // console.log(request);

  let client;
  const { carpeta, pais, vence, marca } = request.body;
  let anD = "";
  let cmd = "";

  let filter = "where ";
  console.log("carpeta " + carpeta);

  if (carpeta) {
    console.log("carpeta in");
    cmd = filter + "carpeta like '" + carpeta.toString() + "%' ";
    anD = " AND ";
    filter = "";
  }
  console.log("cmd " + cmd);

  if (pais) {
    cmd += filter + anD + "pais like '" + pais + "%' ";
    anD = " AND ";
    filter = "";
  }

  if (vence) {
    cmd += filter + anD + " vence like '" + vence + "%' ";
    anD = " AND ";
  }

  if (marca) {
    cmd += filter + anD + "marca like '" + marca + "%' ";
    filter = "";
  }

  const query = {
    text: s_richelet + cmd + "  limit 40;"
  };

  client = new Client({
    user: "postgres",
    host: "localhost",
    database: "richelet",
    password: "postgres",
    port: 5432
  });

  client.connect();
  client.query(query, (err, res) => {
    if (err) {
      console.log(err.stack);
    } else {
      //  console.log("ok"+JSON.stringify(res.rows));
      // client.end();
      response.status(200).json(res.rows);
    }
  });
});

app.post("/api/password", (request, response) => {
  let p = [];

  p.push(request.body.user);
  p.push(request.body.password);

  const client = new Client({
    user: "react_db_user",
    host: "localhost",
    database: "react_db",
    password: "r34cts",
    port: 5432
  });
  console.log("1*");
  console.log(p);
  const query = {
    text:
      "select * from register  WHERE email = $1  AND clave = crypt( $2 , clave);",
    values: p
  };

  client.connect();

  client.query(query, p, (err, res) => {
    if (err) {
      console.log("error");
      console.log(err.stack);
    } else {
      console.log("NOO error");
      client.end();
     
      console.log( JSON.stringify(res) );
      response.status(200).json( JSON.stringify(res ));
    }
  });
});

app.post("/api/changeState", (request, response) => {
  // console.log(request);

  const client = new Client({
    user: "react_db_user",
    host: "localhost",
    database: "react_db",
    password: "r34cts",
    port: 5432
  });

  client.connect();
  client.query(
    "update mensajes set estado =" +
      request.body.estado +
      " where id = " +
      request.body.id +
      " ;",
    (err, res) => {
      if (err) {
        console.log(err.stack);
      } else {
        client.end();
        console.log(JSON.stringify(res));
        response.status(200).json(res.rows);
      }
    }
  );
});

app.post("/api/register", (request, response) => {
  /*
   */
  let p = [];

  const client = new Client({
    user: "react_db_user",
    host: "localhost",
    database: "react_db",
    password: "",
    port: 5432
  });

  p.push(request.body.nombre);
  p.push(request.body.direccion);
  p.push(request.body.email);
  p.push(request.body.password);

  const query = {
    text: "select createuser($1,$3,$2,$4)",
    values: p
  };

  client.connect();
  client.query(query, p, (err, res) => {
    if (err) {
      console.log(err.stack);
    } else {
      console.log("ok");
      client.end();
      response.status(200).json({ resp: res });
    }
  });
});

app.post("/api/consultas", (request, response) => {
  // console.log(request.body);
  let p = [];
  p.push(request.body.consulta);
  p.push(request.body.nombreApellido);
  p.push(request.body.telefonoOcelular);
  p.push(request.body.email);
  p.push(request.body.direccion);
  p.push(request.body.localidad);

  console.log(p);
  console.log(
    "---------------------------------------------------------------------------"
  );

  const query = {
    text:
      "insert into mensajes( comentario ,nombre_apellido,telefono,email, direccion,localidad)  values($1,$2,$3,$4,$5,$6);",
    values: p,
    rowMode: "array"
  };

  console.log("client.query");
  client.connect();
  client.query(query, p, (err, res) => {
    if (err) {
      console.log(err.stack);
    } else {
      console.log("ok");
      client.end();
      response.status(200).json({ resp: res });
    }
  });
});

app.post("/api/removeRow", (request, response) => {
  let p = [];
  let client = new Client({
    user: "react_db_user",
    host: "localhost",
    database: "react_db",
    password: "r34cts",
    port: 5432
  });

  console.log(request.body);
  p.push(request.body.id);
  const query = {
    text: "delete from  mensajes where id= $1",
    values: p,
    rowMode: "array"
  };

  client.connect();
  client.query(query, p, (err, res) => {
    if (err) {
      console.log(err.stack);
    } else {
      console.log("ok");
      client.end();
      response.status(200).json({ resp: res });
    }
  });
});

app.get("/api/consultas", (request, response) => {
  console.log(request.query);
  console.log(request.body);
  response.status(200).json({ resp: "request.body" });
});

const port = 5000;

app.listen(port, () => `Server running on port ${port}`);
